(function ($) {
    'use strict';

    $(document).ready(function ($) {

        $('#cbcurrencyconverter_info_trig').on('click', function (e) {
            e.preventDefault();

            $('#cbcurrencyconverter_resetinfo').toggle();
        });

        //choosen color

        $('.selecttwo-select').select2({
            placeholder: wpcbcurrencyconverter.please_select,
            allowClear: false
        });

        //Initiate Color Picker
        $('.wp-color-picker-field').wpColorPicker();

        // Switches option sections
        //$('.cbcurrencyconverter_group').hide();
        var activetab = '';
        if (typeof (localStorage) !== 'undefined') {
            activetab = localStorage.getItem('cbcurrencyconverter');
        }

        //if url has section id as hash then set it as active or override the current local storage value
        if (window.location.hash) {
            if ($(window.location.hash).hasClass('cbcurrencyconverter_group')) {
                activetab = window.location.hash;
                if (typeof (localStorage) !== 'undefined') {
                    localStorage.setItem('cbcurrencyconverter', activetab);
                }
            }
        }


        if (activetab !== '' && $(activetab).length && $(activetab).hasClass('cbcurrencyconverter_group')) {
            $('.cbcurrencyconverter_group').hide();
            $(activetab).fadeIn();
        }


        if (activetab !== '' && $(activetab + '-tab').length) {
            $('.nav-tab-wrapper a.nav-tab').removeClass('nav-tab-active');
            $(activetab + '-tab').addClass('nav-tab-active');
        }


        $('.nav-tab-wrapper a').on('click', function (e) {
            e.preventDefault();

            var $this = $(this);

            $('.nav-tab-wrapper a.nav-tab').removeClass('nav-tab-active');
            $this.addClass('nav-tab-active').blur();

            var clicked_group = $(this).attr('href');

            if (typeof (localStorage) !== 'undefined') {
                localStorage.setItem('cbcurrencyconverter', $(this).attr('href'));
            }
            $('.cbcurrencyconverter_group').hide();
            $(clicked_group).fadeIn();
        });

        $('.wpsa-browse').on('click', function (event) {
            event.preventDefault();

            var self = $(this);

            // Create the media frame.
            var file_frame = wp.media.frames.file_frame = wp.media({
                title: wpcbcurrencyconverter.upload_title,
                button: {
                    text: wpcbcurrencyconverter.upload_btn
                },
                multiple: false
            });

            file_frame.on('select', function () {
                var attachment = file_frame.state().get('selection').first().toJSON();

                self.prev('.wpsa-url').val(attachment.url);
            });

            // Finally, open the modal
            file_frame.open();
        });

        $('.cbcurrencyconverter_group').each(function (index, element) {
            var $element    = $(element);
            var $form_table = $element.find('.form-table');
            $form_table.prev('h2').remove();
        });


        $('.cbcurrencyconverter_group').on('click', '.checkbox', function () {
            var mainParent = $(this).closest('.checkbox-toggle-btn');
            if ($(mainParent).find('input.checkbox').is(':checked')) {
                $(mainParent).addClass('active');
            } else {
                $(mainParent).removeClass('active');
            }

        });

        //one click save setting for the current tab
        $('#save_settings').on('click', function (e) {
            e.preventDefault();

            var $current_tab = $('.nav-tab.nav-tab-active');
            var $tab_id      = $current_tab.data('tabid');
            $('#' + $tab_id).find('.submit_cbcurrencyconverter').trigger('click');
        });

        //copy shortcode
        $('.shortcode_demo_btn').on('click', function (event) {
            event.preventDefault();

            var $this      = $(this);
            var $target    = $this.data('target-cp');
            var $copy_area = $($target);

            $copy_area.focus();
            $copy_area.select();

            try {
                var successful = document.execCommand('copy');
                if (successful) {
                    $this.text(wpcbcurrencyconverter.copy_success);
                    $this.addClass('copy_success');
                } else {
                    $this.text(wpcbcurrencyconverter.copy_fail);
                    $this.addClass('copy_fail');
                }
            } catch (err) {
                $this.text(wpcbcurrencyconverter.copy_fail);
                $this.addClass('copy_fail');
            }

        });//end copy shortcode


        /*$('div.widgets-sortables')
            .on('sortstop', function (event, ui) {
                // only if this widget has the proper identifier...do something
                if (ui.item.find('.selecttwo-select').length == 0)
                    return;




                var item_parent_id = ui.item.closest('.widget').attr('id');


                ui.item.find('.selecttwo-select').select2({
                    dropdownParent: $('#'+item_parent_id),
                    placeholder: wpcbcurrencyconverter.please_select,
                    allowClear: false
                });
            });*/


    });

})(jQuery);