<?php

/**
 * currencylayer.com Api Free
 *
 * Class CBCurrencyConverterCurrencyLayerFree
 */
class CBCurrencyConverterCurrencyLayerFree{
    /**
     * currencylayer.com api method
     *
     * @since 2.8.1
     *
     * @param     $convertion_value
     * @param     $price
     * @param     $convert_from
     * @param     $convert_to
     * @param int $decimalpoint
     *
     * @return string
     */
    public static function api_method( $convertion_value = 0, $price, $convert_from, $convert_to, $decimalpoint = 2 ) {
        $setting = new CBCurrencyconverterSetting();

        $cache         = intval( $setting->get_option( 'cbcurrencyconverter_ratecache', 'cbcurrencyconverter_global_settings', 1 ) ); //from version 2.7.1
        $cache_time_hr = intval( $setting->get_option( 'cbcurrencyconverter_cachetime', 'cbcurrencyconverter_global_settings', 2 ) ); //from version 2.7.1

        if ( $cache ) {
            // Get any existing copy of our transient data
            if ( false === ( $convertion_cache = get_transient( 'cbcurrencyconverter_currencylayerfree' ) ) ) {
                $convertion_cache                                    = array();
                $convertion_value                                    = CBCurrencyConverterCurrencyLayerFree::api_get( $convert_from, $convert_to );
                $convertion_cache[ $convert_from . '-' . $convert_to ] = $convertion_value;
                $convertion_cache                                    = maybe_serialize( $convertion_cache );

                //https://codex.wordpress.org/Transients_API
                set_transient( 'cbcurrencyconverter_currencylayerfree', $convertion_cache, $cache_time_hr * HOUR_IN_SECONDS );

                $convertion_value = $convertion_value * $price;
                $convertion_value = apply_filters( 'cbcurrencyconverter_rate_final', $convertion_value, $price, $convert_from, $convert_to, $decimalpoint );

                return number_format_i18n( $convertion_value, $decimalpoint );
            }

            $convertion_cache = maybe_unserialize( $convertion_cache );
            if ( isset( $convertion_cache[ $convert_from . '-' . $convert_to ] ) ) {
                $convertion_value = $convertion_cache[ $convert_from . '-' . $convert_to ];
            } else {
                $convertion_value                                    = CBCurrencyConverterCurrencyLayerFree::api_get( $convert_from, $convert_to );
                $convertion_cache[ $convert_from . '-' . $convert_to ] = $convertion_value;
                $convertion_cache                                    = maybe_serialize( $convertion_cache );

                //https://codex.wordpress.org/Transients_API
                set_transient( 'cbcurrencyconverter_currencylayerfree', $convertion_cache, $cache_time_hr * HOUR_IN_SECONDS );
            }
        } else {
            $convertion_value = CBCurrencyConverterCurrencyLayerFree::api_get( $convert_from, $convert_to );
        }


        //return number_format_i18n( ( $convertion_value * $price ), $decimalpoint );
        //return number_format_i18n( ( $convertion_value * $price ), $decimalpoint );

        $convertion_value = $convertion_value * $price;
        $convertion_value = apply_filters( 'cbcurrencyconverter_rate_final', $convertion_value, $price, $convert_from, $convert_to, $decimalpoint );

        return number_format_i18n( $convertion_value, $decimalpoint );
    }//end api_method

    /**
     * api request to currencylayer.com
     *
     * @since 2.8.1
     *
     * @param $convert_from
     * @param $convert_to
     *
     * @return int
     */
    public static function api_get( $convert_from, $convert_to ) {
        $setting = new CBCurrencyconverterSetting();
        $api_key = $setting->get_option( 'apikey_clayer_free', 'cbcurrencyconverter_global_settings', '' );

        if ( $api_key == '' ) {
            return 0;
        }

        //only for base currency USD
        if($convert_from != 'USD') return 0;



        $url = 'http://api.currencylayer.com/live?source=USD&access_key='.$api_key;
        $ch  = curl_init();

        curl_setopt( $ch, CURLOPT_URL, $url );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt( $ch, CURLOPT_HEADER, 0 );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
        $body = curl_exec( $ch );

        curl_close( $ch );

        $result = json_decode( $body, true );

        if(isset($result['success']) && ($result['success'] == 1 || $result['success'] === true || $result['success'] === 'true') && isset($result['quotes'])){
            $quotes = $result['quotes'];

            $currency_key_to = 'USD'.$convert_to;
            if(is_array($quotes) && isset($quotes[$currency_key_to])){
                return $quotes[$currency_key_to];
            }
        }

        return 0;
    }//end api_get
}//end class CBCurrencyConverterCurrencyLayerFree
