<?php
	// Prevent direct file access
	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}


	class CBCurrencyConverter_WPBWidget extends WPBakeryShortCode {
		/**
		 * Constructor.
		 */
		public function __construct() {
			add_action( 'init', array( $this, 'bakery_shortcode_mapping' ) );
		}// /end of constructor

		/**
		 * Element Mapping
		 */
		public function bakery_shortcode_mapping() {
			// Map the block with vc_map()
			vc_map( array(
				"name"        => esc_html__( "CBX Currency Converter", 'cbcurrencyconverter' ),
				"description" => esc_html__( "CBX Currency Converter Widget", 'cbcurrencyconverter' ),
				"base"        => "cbcurrencyconverter",
				"icon"        => CBCURRENCYCONVERTER_ROOT_URL . 'assets/images/icon.png',
				"category"    => esc_html__( 'CBX Widgets', 'cbcurrencyconverter' ),
				"params"      => apply_filters( 'cbcurrencyconverter_wpbakery_params', array(
						array(
							'type'        => 'dropdown',
							'heading'     => esc_html__( 'Layout', 'cbcurrencyconverter' ),
							'param_name'  => 'layout',
							'admin_label' => true,
							'value'       => CBCurrencyConverterHelper::get_layouts_r(),
							'std'         => 'cal',
						),
						array(
							"type"        => "textfield",
							"class"       => "",
							'admin_label' => false,
							"heading"     => esc_html__( 'Decimal Point', 'cbcurrencyconverter' ),
							"param_name"  => "decimalpoint",
							'std'         => 2
						),
						//Calculator Settings
						array(
							'type'        => 'textfield',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'Calculator Header', 'cbcurrencyconverter' ),
							'param_name'  => 'calc_title',
							'std'         => esc_html__( 'Currency Calculator', 'cbcurrencyconverter' ),
							'group'       => esc_html__( 'Calculator Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'cbccdropdownmulti',
							"class"       => "",
							'admin_label' => false, //it must be false
							'heading'     => esc_html__( 'Enable Currencies', 'cbcurrencyconverter' ),
							'param_name'  => 'calc_currencies',
							'value'       => CBCurrencyConverterHelper::getCurrencyList_r(),
							'std'         => array( 'USD', 'GBP', 'CAD', 'AUD' ),
							'group'       => esc_html__( 'Calculator Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'dropdown',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'Calculator From Currency', 'cbcurrencyconverter' ),
							'param_name'  => 'calc_from_currency',
							'value'       => CBCurrencyConverterHelper::getCurrencyList_r(),
							'std'         => 'USD',
							'group'       => esc_html__( 'Calculator Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'dropdown',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'Calculator To Currency', 'cbcurrencyconverter' ),
							'param_name'  => 'calc_to_currency',
							'value'       => CBCurrencyConverterHelper::getCurrencyList_r(),
							'std'         => 'CAD',
							'group'       => esc_html__( 'Calculator Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'textfield',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'Default Amount for Calculator', 'cbcurrencyconverter' ),
							'param_name'  => 'calc_default_amount',
							'std'         => 1,
							'group'       => esc_html__( 'Calculator Settings', 'cbcurrencyconverter' ),
						),
						//List Settings
						array(
							'type'        => 'textfield',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'List Header', 'cbcurrencyconverter' ),
							'param_name'  => 'list_title',
							'std'         => esc_html__( 'List of Currency', 'cbcurrencyconverter' ),
							'group'       => esc_html__( 'List Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'dropdown',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'list From Currency', 'cbcurrencyconverter' ),
							'param_name'  => 'list_from_currency',
							'value'       => CBCurrencyConverterHelper::getCurrencyList_r(),
							'std'         => 'USD',
							'group'       => esc_html__( 'List Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'cbccdropdownmulti',
							"class"       => "",
							'admin_label' => false,//it must be false
							'heading'     => esc_html__( 'list To Currency', 'cbcurrencyconverter' ),
							'param_name'  => 'list_to_currency',
							'value'       => CBCurrencyConverterHelper::getCurrencyList_r(),
							'std'         => array( 'GBP', 'CAD', 'AUD' ),
							'group'       => esc_html__( 'List Settings', 'cbcurrencyconverter' ),
						),
						array(
							'type'        => 'textfield',
							"class"       => "",
							'admin_label' => false,
							'heading'     => esc_html__( 'Default Amount for list', 'cbcurrencyconverter' ),
							'param_name'  => 'list_default_amount',
							'std'         => 1,
							'group'       => esc_html__( 'List Settings', 'cbcurrencyconverter' ),
						),

					)
				)
			) );
		}//end bakery_shortcode_mapping
	}// end class CBCurrencyConverter_WPBWidget